// LENS

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, StdCtrls, ExtCtrls,
  BMDSpinEdit;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    seRadius: TBMDSpinEdit;
    sePower: TBMDSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure seRadiusChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  tfm: array [0..127, 0..127] of word;

  sin1, sin2: array [0..255] of byte;

  RADIUS: integer;

  Aborted: Boolean;
  
const
 screen_width = 256;
 screen_height = 256;

implementation

{$R *.dfm}

procedure calc_table(const r: integer);
var s, z: double;
    x, y, a, b: integer;
    POWER: integer;
begin

 RADIUS := r;
 POWER  := form1.sePower.position;;

 S := sqrt( sqr(RADIUS) - sqr(POWER) );

FOR Y:=-RADIUS TO RADIUS-1 do
    FOR X:=-RADIUS TO RADIUS-1 do begin

        IF x*x+y*y >= s*s THEN begin
          A:=X;
          B:=Y;
        end else begin
          Z:=sqrt( sqr(RADIUS)- sqr(x) - sqr(y) );
          A:=round(X*POWER/Z);
          B:=round(Y*POWER/Z);
        end;

       TFM[X+RADIUS , Y+RADIUS]:= (B+RADIUS) or (A+RADIUS) shl 8;

    end;

end;


procedure calc_sinus;
var i: integer;
    k: double;
begin
 k := 0;

 for i := 0 to 255 do begin

  sin1[i] := round(2*sin(k)*pi);
  sin2[i] := round(3*cos(k)*pi);

  k := k+6.284/128;

 end;

end;


procedure TForm1.Button1Click(Sender: TObject);
var x,y, u,v: integer;
    bmp, texture: TBitmap;
    px, py: byte;
    anm1,anm2,anm3,anm4: byte;
begin

 bmp:=TBitmap.Create;
 bmp.PixelFormat:=pf24bit;
 bmp.Width:=screen_width;
 bmp.Height:=screen_height;

 texture:=TBitmap.Create;
 texture.LoadFromFile('t64_15.bmp');
 texture.PixelFormat:=pf24bit;

 bmp.Assign(texture);


 calc_table(form1.seRadius.Position);
 calc_sinus;


 Aborted:=false;

 anm1:=0;
 anm2:=16;
 anm3:=48;
 anm4:=96;

 repeat

  sleep(15);

  Application.ProcessMessages;
  if Aborted then Break;

  for y:=0 to radius shl 1-1 do
   for x:=0 to radius shl 1-1 do begin

    u:=tfm[ x,y ] shr 8;
    v:=tfm[ x,y ] and $ff;

    bmp.Canvas.Pixels[x + px, y + py] := texture.canvas.pixels[u + px, v + py];

   end;

  form1.Image1.Picture.Graphic:=bmp;

  px:=sin1[anm1]+sin2[anm2]+16;
  py:=sin2[anm3]+sin2[anm4]+16;

  inc(anm1);
  inc(anm2,2);
  inc(anm3,2);
  inc(anm4);

 until false;

bmp.Free;
texture.Free;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 doublebuffered := true;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
 if key=#27 then Aborted:=true;
end;


procedure TForm1.seRadiusChange(Sender: TObject);
var c: char;
begin
 c:=#27;
 FormKeyPress(self,c);
end;

end.
